/**
 *
 */
package keesun;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

/**
 * @author keesun
 *
 */
public class PathGenerator {

	protected static PathList pathList = new PathList();

	public static void main(String[] args) {
		Display display = new Display();
		final Shell shell = new Shell(display);
		shell.setText("Path Generator");
		shell.setImage(new Image(display, "keesun.ico"));

		final Text pathText = new Text(shell, SWT.BORDER | SWT.MULTI | SWT.WRAP | SWT.V_SCROLL);

		final Button nateOnButton = new Button(shell, SWT.PUSH);
		nateOnButton.setBounds(0, 0, 100, 25);
		nateOnButton.setText("Nate On");
		nateOnButton.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				String label = nateOnButton.getText();
				setPathTest(label, pathText);
			}
		});

		final Button okButton = new Button(shell, SWT.PUSH);
		okButton.setBounds(100, 0, 100, 25);
		okButton.setText("OK");
		okButton.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				String label = okButton.getText();
				setPathTest(label, pathText);
			}
		});

		final Button messageButton = new Button(shell, SWT.PUSH);
		messageButton.setBounds(200, 0, 100, 25);
		messageButton.setText("Message");
		messageButton.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				String label = messageButton.getText();
				setPathTest(label, pathText);
			}
		});

		final Button callButton = new Button(shell, SWT.PUSH);
		callButton.setBounds(0, 25, 100, 25);
		callButton.setText("Call");
		callButton.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				String label = callButton.getText();
				setPathTest(label, pathText);
			}
		});

		final Button menuButton = new Button(shell, SWT.PUSH);
		menuButton.setBounds(100, 25, 100, 25);
		menuButton.setText("Menu");
		menuButton.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				String label = menuButton.getText();
				setPathTest(label, pathText);
			}
		});

		final Button arrowButton = new Button(shell, SWT.PUSH);
		arrowButton.setBounds(200, 25, 100, 25);
		arrowButton.setText("Arrow");
		arrowButton.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				String label = arrowButton.getText();
				setPathTest(label, pathText);
			}
		});

		pathText.setBounds(0, 50, 300, 50);
		pathText.setText("here is where the generated path will be made by");

		final Button copyButton = new Button(shell, SWT.PUSH);
		copyButton.setBounds(0, 100, 100, 25);
		copyButton.setText("복사");
		copyButton.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				pathText.selectAll();
				pathText.copy();
			}
		});

		final Button cancleButton = new Button(shell, SWT.PUSH);
		cancleButton.setBounds(100, 100, 100, 25);
		cancleButton.setText("취소");
		cancleButton.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				cancleLastPathText(pathText);
			}
		});

		final Button removeButton = new Button(shell, SWT.PUSH);
		removeButton.setBounds(200, 100, 100, 25);
		removeButton.setText("모두 삭제");
		removeButton.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				removeAll(pathText);
			}
		});

		shell.pack();
		shell.open();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
		display.dispose();
	}

	/**
	 * @param pathText 모두 삭제
	 */
	protected static void removeAll(Text pathText) {
		pathList.removeAll();
		pathText.setText("");
	}

	/**
	 * @param pathText 맨 마지막에 추가된 요소 삭제
	 */
	protected static void cancleLastPathText(Text pathText) {
		pathList.removeLast();
		pathText.setText(pathList.toString());
	}

	/**
	 * @param label 텍스트에 추가 할 문자열
	 * @param pathText 변경 할 텍스트
	 */
	protected static void setPathTest(String label, Text pathText) {
		pathList.add(label);
		pathText.setText(pathList.toString());
	}
}
